# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations

import datetime as dt
import typing

import pydantic
import typing_extensions

from ...core.datetime_utils import serialize_datetime

T_Result = typing.TypeVar("T_Result")


class _Factory:
    def text(self, value: str) -> DocumentContent:
        return DocumentContent(__root__=_DocumentContent.Text(type="text", value=value))

    def chunks(self, value: typing.List[str]) -> DocumentContent:
        return DocumentContent(__root__=_DocumentContent.Chunks(type="chunks", value=value))


class DocumentContent(pydantic.BaseModel):
    factory: typing.ClassVar[_Factory] = _Factory()

    def get_as_union(self) -> typing.Union[_DocumentContent.Text, _DocumentContent.Chunks]:
        return self.__root__

    def visit(
        self, text: typing.Callable[[str], T_Result], chunks: typing.Callable[[typing.List[str]], T_Result]
    ) -> T_Result:
        if self.__root__.type == "text":
            return text(self.__root__.value)
        if self.__root__.type == "chunks":
            return chunks(self.__root__.value)

    __root__: typing_extensions.Annotated[
        typing.Union[_DocumentContent.Text, _DocumentContent.Chunks], pydantic.Field(discriminator="type")
    ]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}


class _DocumentContent:
    class Text(pydantic.BaseModel):
        type: typing_extensions.Literal["text"]
        value: str

        class Config:
            frozen = True

    class Chunks(pydantic.BaseModel):
        type: typing_extensions.Literal["chunks"]
        value: typing.List[str]

        class Config:
            frozen = True


DocumentContent.update_forward_refs()
